<?php
/**
 * $Horde: wicked/view.php,v 1.7 2008-01-02 11:14:12 jan Exp $
 *
 * Copyright 2004-2008 The Horde Project (http://www.horde.org/)
 *
 * See the enclosed file COPYING for license information (GPL). If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 *
 * @author Jason Felice <jason.m.felice@gmail.com>
 */

@define('WICKED_BASE', dirname(__FILE__));
require_once WICKED_BASE . '/lib/base.php';
require_once 'Horde/MIME/Magic.php';

$page = Util::getFormData('page', 'WikiHome');
$file = Util::getFormData('file');
$mime = Util::getFormData('mime');

$id = $wicked->getPageId($page);
if ($id !== false) {
    $page_id = $id;
} else {
    $page_id = $page;
}

$version = Util::getFormData('version');
if (empty($version)) {
    $attachments = $wicked->getAttachedFiles($page_id);
    if (is_a($attachments, 'PEAR_Error')) {
        // If we redirect here, we cause an infinite loop with inline
        // attachments.
        header('HTTP/1.1 404 Not Found');
        exit;
    }

    foreach ($attachments as $attachment) {
        if ($attachment['attachment_name'] == $file) {
            $version = $attachment['attachment_majorversion'] . '.' .
                       $attachment['attachment_minorversion'];
        }
    }

    if (empty($version)) {
        // If we redirect here, we cause an infinite loop with inline
        // attachments.
        header('HTTP/1.1 404 Not Found');
        exit;
    }
}

$data = $wicked->getAttachmentContents($page_id, $file, $version);
if (is_a($data, 'PEAR_Error')) {
    // If we redirect here, we cause an infinite loop with inline
    // attachments.
    header('HTTP/1.1 404 Not Found');
    echo $data->getMessage();
    exit;
}

$type = MIME_Magic::analyzeData($data, isset($conf['mime']['magic_db']) ? $conf['mime']['magic_db'] : null);
if ($type === false) {
    $type = MIME_Magic::filenameToMIME($file, false);
}

$browser->downloadHeaders($file, $type, !empty($mime), strlen($data));
echo $data;
